40a58e6d91fc045dcf1d95a0529772dfe52c89a0
[ric-plt/lib/rmr.git] / test / app_test / run_call_test.ksh
1 #!/usr/bin/env ksh
2 # :vi ts=4 sw=4 noet :
3 #==================================================================================
4 #    Copyright (c) 2019 Nokia
5 #    Copyright (c) 2018-2019 AT&T Intellectual Property.
6 #
7 #   Licensed under the Apache License, Version 2.0 (the "License");
8 #   you may not use this file except in compliance with the License.
9 #   You may obtain a copy of the License at
10 #
11 #       http://www.apache.org/licenses/LICENSE-2.0
12 #
13 #   Unless required by applicable law or agreed to in writing, software
14 #   distributed under the License is distributed on an "AS IS" BASIS,
15 #   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
16 #   See the License for the specific language governing permissions and
17 #   limitations under the License.
18 #==================================================================================
19 #
20
21 # ---------------------------------------------------------------------------------
22 #       Mnemonic:       run_call_test.ksh
23 #       Abstract:       This is a simple script to set up and run the basic send/receive
24 #                               processes for some library validation on top of nng.
25 #                               It should be possible to clone the repo, switch to this directory
26 #                               and execute  'ksh run -B'  which will build RMr, make the sender and
27 #                               recevier then  run the basic test.
28 #
29 #                               The call test drives three RMr based processes:
30 #                                       caller which invokes rmr_mt_call() to send n messages
31 #
32 #                                       receiver which executes rmr_rts_msg() on each received
33 #                                               message with type == 5.
34 #       
35 #                                       sender which sends n "pings" to the caller process
36 #
37 #                               The script assumes that all three proessess are running on the same
38 #                               host/container such that setting up the route table with localhost:port
39 #                               will work.
40 #
41 #                               The number of message, and the delay between each message may be given
42 #                               on the command line. The number of threads may also be given. The
43 #                               number of messages defines the number _each_ caller will sent (5000 
44 #                               messages and three threads == 15,000 total messages.
45 #
46 #                               Example command line:
47 #                                       ksh ./run_call_test.ksh         # default 10 messages at 1 msg/sec 3 threads
48 #                                       ksh ./run_call_test.ksh -n 5000  -t 6 -d 400    # 5k messages, 6 threads, delay 400 mus
49 #
50 #       Date:           20 May 2019
51 #       Author:         E. Scott Daniels
52 # ---------------------------------------------------------------------------------
53
54
55 # The sender and receiver are run asynch. Their exit statuses are captured in a
56 # file in order for the 'main' to pick them up easily.
57 #
58 function run_sender {
59         ./caller $nmsg $delay $nthreads
60         echo $? >/tmp/PID$$.src         # must communicate state back via file b/c asynch
61 }
62
63 # start receiver listening for nmsgs from each thread
64 function run_rcvr {
65         ./mt_receiver $(( nmsg * nthreads ))            # we'll test with the RMr multi threaded receive function
66         echo $? >/tmp/PID$$.rrc
67 }
68
69 # This will send 100 messages to the caller process. This is a test to verify that
70 # threaded calling is not affected by normal messages and that normal messages can
71 # be received concurrently.
72 #
73 function run_pinger {
74     RMR_RTG_SVC=9999 ./sender 100 100 4 3333 >/dev/NULL 2>&1  # send pings
75 }
76
77
78 # Generate a route table that is tailored to our needs of sender sending messages to
79 # the caller, and caller sending mtype == 5 to the receiver.
80 #
81 function mk_rt {
82
83 cat <<endKat >caller.rt
84 # this is a specialised rt for caller testing. mtype 5 go to the
85 # receiver, and all others go to the caller.
86
87 newrt | start
88 mse | 0 |  0 | localhost:43086
89 mse | 1 | 10 | localhost:43086
90 mse | 2 | 20 | localhost:43086
91 rte | 3 | localhost:43086
92 mse | 3 | 100 | localhost:43086 # special test to ensure that this does not affect previous entry
93 rte | 4 | localhost:43086
94 rte | 5 | localhost:4560
95 rte | 6 | localhost:43086
96 rte | 7 | localhost:43086
97 rte | 8 | localhost:43086
98 rte | 9 | localhost:43086
99 rte | 10 | localhost:43086
100 rte | 11 | localhost:43086
101 rte | 12 | localhost:43086
102 rte | 13 | localhost:43086
103
104 newrt | end | 16
105 endKat
106 }
107
108 # ---------------------------------------------------------
109
110 nmsg=10                                         # total number of messages to be exchanged (-n value changes)
111 delay=1000000                           # microsec sleep between msg 1,000,000 == 1s
112 wait=1
113 rebuild=0
114 verbose=0
115 nthreads=3
116 dev_base=1                                      # -D turns off to allow this to run on installed libs
117
118
119
120 while [[ $1 == -* ]]
121 do
122         case $1 in
123                 -B)     rebuild=1;;
124                 -d)     delay=$2; shift;;
125                 -D)     dev_base=0;;
126                 -n)     nmsg=$2; shift;;
127                 -t)     nthreads=$2; shift;;
128                 -v)     verbose=1;;
129
130                 *)      echo "unrecognised option: $1"
131                         echo "usage: $0 [-B] [-d micro-sec-delay] [-n num-msgs] [-t num-threads]"
132                         echo "  -B forces a rebuild which will use .build"
133                         exit 1
134                         ;;
135         esac
136
137         shift
138 done
139
140 if (( verbose ))
141 then
142         echo "2" >.verbose
143         export RMR_VCTL_FILE=".verbose"
144 fi
145
146 if (( rebuild ))
147 then
148         build_path=../../.build
149         set -e
150         ksh ./rebuild.ksh
151         set +e
152 else
153         build_path=${BUILD_PATH:-"../../.build"}        # we prefer .build at the root level, but allow user option
154
155         if [[ ! -d $build_path ]]
156         then
157                 echo "cannot find build in: $build_path"
158                 echo "either create, and then build RMr, or set BUILD_PATH as an evironment var before running this"
159                 exit 1
160         fi
161 fi
162
163 if (( dev_base ))                                                       # assume we are testing against what we've built, not what is installed
164 then
165         if [[ -d $build_path/lib64 ]]
166         then
167                 export LD_LIBRARY_PATH=$build_path:$build_path/lib64
168         else
169                 export LD_LIBRARY_PATH=$build_path:$build_path/lib
170         fi
171 else                                                                            # -D option gets us here to test an installed library
172         export LD_LIBRARY_PATH=/usr/local/lib
173         export LIBRARY_PATH=$LD_LIBRARY_PATH
174 fi
175
176 export RMR_SEED_RT=${RMR_SEED_RT:-./caller.rt}          # allow easy testing with different rt
177
178 if [[ ! -f $RMR_SEED_RT ]]                                                      # special caller rt for three process setup
179 then
180         mk_rt
181 fi
182
183 if [[ ! -f ./sender ]]
184 then
185         if ! make >/dev/null 2>&1
186         then
187                 echo "[FAIL] cannot find sender binary, and cannot make it.... humm?"
188                 exit 1
189         fi
190 fi
191
192 run_rcvr &
193 sleep 2                         # if caller starts faster than rcvr we can drop, so pause a bit
194 run_sender &
195 run_pinger &
196
197 wait
198 head -1 /tmp/PID$$.rrc | read rrc               # get pass/fail state from each
199 head -1 /tmp/PID$$.src | read src
200
201 if (( !! (src + rrc) ))
202 then
203         echo "[FAIL] sender rc=$src  receiver rc=$rrc"
204 else
205         echo "[PASS] sender rc=$src  receiver rc=$rrc"
206 fi
207
208 rm /tmp/PID$$.*
209 rm -f .verbose
210
211 exit $(( !! (src + rrc) ))
212